public class OpstiTipoviPrimeri {

	public static void main(String[] args) {
		Par<String> pstr = new Par<String>("a", "b");
		System.out.println(pstr);
		Par<String> kop = pstr.kopija();
		kop.zameni();
		System.out.println(kop);

		Par<Double> dd = new Par<>(2.0, 2.0);
		System.out.println(
				"u ovom paru su isti brojevi:" + dd.jednakiPrviIDrugi());

		Par<Integer> pint = new Par<Integer>(2, 8);
		System.out.println(pint);

		Par<Integer> intovi = new Par<Integer>();
		intovi.prviel = 2;
		intovi.drugiel = 8;

		System.out.println("jednaki su:" + pint.jednakSaParom(intovi));
	}
}

class Par<T> {
	// tip za polja je zadat parametrom uz ime klase
	T prviel, drugiel;

	public Par(T podatak1, T podatak2) {
		this.prviel = podatak1;
		this.drugiel = podatak2;
	}

	public Par() {
		this.prviel = null;
		this.drugiel = null;
	}

	public String toString() {
		return "Par (" + prviel + ", " + drugiel + ")";
	}

	public boolean jednakiPrviIDrugi() {
		if (prviel == null)
			return drugiel == null;
		else
			return prviel.equals(drugiel);
	}

	public void zameni() {
		T pom = prviel;
		prviel = drugiel;
		drugiel = pom;
	}

	public Par<T> kopija() {
		return new Par<T>(prviel, drugiel);
	}

	public boolean jednakSaParom(Par<T> par2) {
		if (par2 == null)
			return false;
		// moramo proveravati da li su null elementi, pa ima vise mogucnosti
		if ((prviel == null) != (par2.prviel == null))
			return false;
		if (prviel != null && !prviel.equals(par2.prviel))
			return false;
		if ((drugiel == null) != (par2.drugiel == null))
			return false;
		if (drugiel != null && !drugiel.equals(par2.drugiel))
			return false;

		// nismo nasli razliku
		return true;
	}
}
